
#include <SFE_BMP180.h> //BMP180 library
#include <Wire.h> //BMP180 library
#include "Talkie.h" // Speaker library 
#include "Vocab_US_Large.h" //Speaker library
#include "Vocab_Special.h" //Speaker library 
#include <TinyGPS++.h> //GPS library
#include <SoftwareSerial.h> //GPS library 

Talkie voice; //initialize voice variable 

static const int RXPin = 4, TXPin = 3; 
static const uint32_t GPSBaud = 9600;


TinyGPSPlus gps; //initialize GPS variable

SoftwareSerial ss(RXPin, TXPin);

int led1 = 2; 
int led2 = 5; 
int led3 = 6; 
int led4 = 7;
int led5 = 8; 
int led6 = 9; 
int led7 = 12; 
int led8 = 13; 
 
int threshold_failed = 1; 

int intvalue; 

SFE_BMP180 pressure;

double baseline;


void setup() {
Serial.begin(9600);
Serial.println("REBOOT");

  if (pressure.begin())
    Serial.println("BMP180 init success");
  else
  {
    Serial.println("BMP180 init fail (disconnected?)\n\n");
    while(1); 
  }
  
  baseline = getPressure();
  
  Serial.print("baseline pressure: ");
  Serial.print(baseline);
  Serial.println(" mb");  

{
  ss.begin(GPSBaud);

  Serial.println(F("DeviceExample.ino"));
  Serial.println(F("A simple demonstration of TinyGPS++ with an attached GPS module"));
  Serial.print(F("Testing TinyGPS++ library v. ")); Serial.println(TinyGPSPlus::libraryVersion());
  Serial.println(F("by Mikal Hart"));
  Serial.println();
}

  {
    
  pinMode (led1, OUTPUT); 
  pinMode (led2, OUTPUT); 
  pinMode (led3, OUTPUT); 
  pinMode (led4, OUTPUT); 
  pinMode (led5, OUTPUT); 
  pinMode (led6, OUTPUT); 
  pinMode (led7, OUTPUT); 
  pinMode (led8, OUTPUT);

  }
  
}
void displayInfo() //location function 
{
  Serial.print(F("Location: ")); 
  if (gps.location.isValid())
  {
    Serial.print(gps.location.lat(), 6);
    Serial.print(F(","));
    Serial.print(gps.location.lng(), 6);
  }
  else
  {
    Serial.print(F("INVALID"));
  }

  Serial.print(F("  Date/Time: "));
  if (gps.date.isValid())
  {
    Serial.print(gps.date.month());
    Serial.print(F("/"));
    Serial.print(gps.date.day());
    Serial.print(F("/"));
    Serial.print(gps.date.year());
  }
  else
  {
    Serial.print(F("INVALID\n"));
  }

  Serial.print(F(" "));
  if (gps.time.isValid())
  {
    if (gps.time.hour() < 10) Serial.print(F("0"));
    Serial.print(gps.time.hour());
    Serial.print(F(":"));
    if (gps.time.minute() < 10) Serial.print(F("0"));
    Serial.print(gps.time.minute());
    Serial.print(F(":"));
    if (gps.time.second() < 10) Serial.print(F("0"));
    Serial.print(gps.time.second());
    Serial.print(F("."));
    if (gps.time.centisecond() < 10) Serial.print(F("0"));
    Serial.print(gps.time.centisecond());
  }
  else
  {
    Serial.print(F("INVALID"));
  }

  Serial.println();
}
void loop() {

{
  Serial.print(F("Location: ")); 
  if (gps.location.isValid())
  {
    Serial.print(gps.location.lat(), 6);
    Serial.print(F(",\n"));
    Serial.print(gps.location.lng(), 6);
  }
  else
  {
    Serial.print(F("INVALID"));
  }

  Serial.print(F("  Date/Time: "));
  if (gps.date.isValid())
  {
    Serial.print(gps.date.month());
    Serial.print(F("/"));
    Serial.print(gps.date.day());
    Serial.print(F("/"));
    Serial.print(gps.date.year());
  }
  else
  {
    Serial.print(F("INVALID"));
  }

  Serial.print(F(" "));
  if (gps.time.isValid())
  {
    if (gps.time.hour() < 10) Serial.print(F("0"));
    Serial.print(gps.time.hour());
    Serial.print(F(":"));
    if (gps.time.minute() < 10) Serial.print(F("0"));
    Serial.print(gps.time.minute());
    Serial.print(F(":"));
    if (gps.time.second() < 10) Serial.print(F("0"));
    Serial.print(gps.time.second());
    Serial.print(F("."));
    if (gps.time.centisecond() < 10) Serial.print(F("0"));
    Serial.print(gps.time.centisecond());
  }
  else
  {
    Serial.print(F("INVALID"));
  }

  Serial.println();
}

  double a,P;

  P = getPressure();

  a = pressure.altitude(P,baseline);
 
  
  Serial.print("relative altitude: ");
  if (a >= 0.0) Serial.print(" "); 
  Serial.print(a,1);
  Serial.print(" meters, ");
  if (a <= 0.0) //if altitude reading 
  {
    while (int threshold_failed = 1) 
    {
      Serial.print("The drone has fallen.\n"); 
      Serial.print("The parachute will be deployed.\n"); 
    
      voice.say(spPAUSE2);
      voice.say(sp2_DANGER);
      voice.say(sp2_DANGER);
      voice.say(sp2_MOVE);
      voice.say(sp2_OPERATOR);
      voice.say(sp2_IS);
      voice.say(sp2_ON);
      voice.say(sp2_ALERT);

     digitalWrite (led1, HIGH);
     delay(100);
 
     digitalWrite (led2, HIGH);
     delay(100);
 
     digitalWrite (led3, HIGH);
     delay(100);
 
     digitalWrite (led4, HIGH);
     delay(100);
 
     digitalWrite (led5, HIGH);
     delay(100);

     digitalWrite (led6, HIGH);
     delay(100);

     digitalWrite (led7, HIGH);
     delay(100);

     digitalWrite (led8, HIGH);
     delay(100);
 
     digitalWrite(led1, LOW);
     delay(100);
 
     digitalWrite(led2, LOW);
     delay(100);
 
     digitalWrite (led3, LOW);
     delay(100);
 
     digitalWrite (led4, LOW);
     delay(100);
 
     digitalWrite (led5, LOW);
     delay(100);

     digitalWrite (led6, LOW);
     delay(100);

     digitalWrite (led7, LOW);
     delay(100);

     digitalWrite (led8, LOW);
     delay(100);
    
  }
  
  delay(500);
    
  }
  
}


double getPressure() //altitude function
{
  char status;
  double T,P,p0,a;
  
  status = pressure.startTemperature();
  if (status != 0)
  {

    delay(status);

    status = pressure.getTemperature(T);
    if (status != 0)
    {

      status = pressure.startPressure(3);
      if (status != 0)
      {
        // Wait for the measurement to complete:
        delay(status);


        status = pressure.getPressure(P,T);
        if (status != 0)
        {
          return(P);
        }
        else Serial.println("error retrieving pressure measurement\n");
      }
      else Serial.println("error starting pressure measurement\n");
    }
    else Serial.println("error retrieving temperature measurement\n");
  }
  else Serial.println("error starting temperature measurement\n");
}
